package shooting_0_17;

import java.applet.Applet;
import java.awt.Button;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import shooting_0_17.game.EasyGame;
import shooting_0_17.game.Game;
import shooting_0_17.game.HardGame;
import shooting_0_17.game.NormalGame;
import utilities.MyGraphics;
import utilities.Repaint;

public class Shooting extends Applet implements ActionListener, KeyListener {

	public static Config config = new Config();

	public static int jikiWidth = Integer.parseInt(config.get("HeroWidth"));
	public static int jikiHeight = Integer.parseInt(config.get("HeroHeight"));
	public static int tekiNormalWidth =
		Integer.parseInt(config.get("NormalEnemyWidth"));
	public static int tekiNormalHeight =
		Integer.parseInt(config.get("NormalEnemyWidth"));

	private int buttonWidth = 100;
	private int buttonHeight = 25;

	private boolean start;
	private boolean started;
	private Button titleButton;
	private Button easyButton;
	private Button normalButton;
	private Button hardButton;
	private Game game;
	protected Graphics offGra;
	protected Image offImage;

	public void init() {
		start = false;
		started = false;
		titleButton = new Button(config.get("ToTitleButtonText"));
		easyButton = new Button(config.get("EasyLevelButtonText"));
		normalButton = new Button(config.get("NormalLevelButtonText"));
		hardButton = new Button(config.get("HardLevelButtonText"));
		titleButton.addActionListener(this);
		easyButton.addActionListener(this);
		normalButton.addActionListener(this);
		hardButton.addActionListener(this);
		add(titleButton);
		add(easyButton);
		add(normalButton);
		add(hardButton);
		easyButton.addKeyListener(this);
		normalButton.addKeyListener(this);
		hardButton.addKeyListener(this);
		addKeyListener(this);
		offImage = createImage(getWidth(), getHeight());
		offGra = offImage.getGraphics();
	}

	public void paint(Graphics g) {
		if (start == false) {
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("BackImage")),
				0,
				0,
				800,
				1000,
				this);
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("HeroImage")),
				450,
				400,
				Integer.parseInt(config.get("HeroWidth")),
				Integer.parseInt(config.get("HeroHeight")),
				this);
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("HeroNormalShotImage")),
				465,
				100,
				15,
				15,
				this);
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("HeroNormalShotImage")),
				465,
				250,
				15,
				15,
				this);
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("NormalEnemyImage1")),
				310,
				70,
				Integer.parseInt(config.get("NormalEnemyWidth")),
				Integer.parseInt(config.get("NormalEnemyHeight")),
				this);
			offGra.drawImage(
				getImage(getDocumentBase(), config.get("NormalEnemyImage2")),
				550,
				70,
				Integer.parseInt(config.get("NormalEnemyWidth")),
				Integer.parseInt(config.get("NormalEnemyHeight")),
				this);
			titleButton.setSize(0, 0);
			easyButton.setSize(buttonWidth, buttonHeight);
			normalButton.setSize(buttonWidth, buttonHeight);
			hardButton.setSize(buttonWidth, buttonHeight);
			easyButton.setLocation(230, 10);
			normalButton.setLocation(350, 10);
			hardButton.setLocation(470, 10);
			MyGraphics.drawStringToCenter(
				this,
				offGra,
				new Font(config.get("GameTitleFont"), Font.BOLD, 50),
				Color.black,
				config.get("GameTitle"));
			g.drawImage(offImage, 0, 0, this);
		} else if (start == true) {
			if (started == false) {
				new Thread(
					new Repaint(
						this,
						Integer.parseInt(config.get("RepaintInterval"))))
					.start();
				started = true;
			}
			if (game.paint(g)) {
				titleButton.setSize(buttonWidth, buttonHeight);
				titleButton.setLocation(350, 10);
			}
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void keyPressed(KeyEvent arg0) {
		if (start == false) {
			return;
		}
		game.keyPressed(arg0);
	}

	public void keyReleased(KeyEvent arg0) {
		if (start == false) {
			return;
		}
		game.keyReleased(arg0);
	}

	public void keyTyped(KeyEvent arg0) {
	}

	public void actionPerformed(ActionEvent arg0) {
		if (start == false) {
			if (arg0.getSource() == normalButton) {
				game = new NormalGame(this);
			} else if (arg0.getSource() == easyButton) {
				game = new EasyGame(this);
			} else if (arg0.getSource() == hardButton) {
				game = new HardGame(this);
			}
			new Thread(game).start();
			start = true;
			easyButton.setSize(0, 0);
			normalButton.setSize(0, 0);
			hardButton.setSize(0, 0);
		}
		if (arg0.getSource() == titleButton) {
			game.getJiki().end();
			titleButton.setSize(0, 0);
			easyButton.setSize(buttonWidth, buttonHeight);
			normalButton.setSize(buttonWidth, buttonHeight);
			hardButton.setSize(buttonWidth, buttonHeight);
			start = false;
		}
	}

}
