package shooting_0_17.game;

import java.applet.Applet;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.lang.reflect.Constructor;
import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

import shooting_0_17.Back;
import shooting_0_17.Drawable;
import shooting_0_17.Shooting;
import shooting_0_17.item.Item;
import shooting_0_17.kitai.Enemy;
import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.shot.BombShot;
import utilities.MyGraphics;

public abstract class Game implements Runnable {
	
	protected int highScore = 0;
	
	protected String AddOptionItem = Shooting.config.get("AddOptionItemImage");
	protected Applet applet;
	protected Back back;
	protected String Back = Shooting.config.get("BackImage");
	protected Enemy boss;
	protected String Boss = Shooting.config.get("BossImage");
	protected String DoubleShotItem =
		Shooting.config.get("DoubleShotItemImage");
	protected Vector drawable;
	protected int EasyLevelShotInterval =
		Integer.parseInt(Shooting.config.get("EasyLevelShotInterval"));
	protected int NormalEnemyWidth =
		Integer.parseInt(Shooting.config.get("NormalEnemyWidth"));
	protected int NormalEnemyHeight =
		Integer.parseInt(Shooting.config.get("NormalEnemyHeight"));
	protected Group group;
	protected int HardLevelShotInterval =
		Integer.parseInt(Shooting.config.get("HardLevelShotInterval"));

	protected String Hero = Shooting.config.get("HeroImage");
	protected int HeroHeight =
		Integer.parseInt(Shooting.config.get("HeroHeight"));
	protected int HeroWidth =
		Integer.parseInt(Shooting.config.get("HeroWidth"));
	protected Jiki jiki;
	protected String NormalEnemy = Shooting.config.get("NormalEnemyImage1");
	protected int NormalLevelShotInterval =
		Integer.parseInt(Shooting.config.get("NormalLevelShotInterval"));
	protected Graphics offGra;
	protected Image offImage;
	protected Random rand;
	protected int score;
	protected String ShotIntervalUpItem =
		Shooting.config.get("ShotIntervalUpItemImage");
	protected String SpeedUpItem = Shooting.config.get("SpeedUpItemImage");
	protected String ThreeWayShotItem =
		Shooting.config.get("ThreeWayShotItemImage");
	protected String TyuBoss = Shooting.config.get("NormalEnemyImage2");
	protected String bossKobun = Shooting.config.get("NormalEnemyImage3");
	protected String FiveWayEnemyImage = Shooting.config.get("NormalEnemyImage4");

	public Game(Applet applet) {
		this.applet = applet;
	}

	protected Enemy addEnemy(
		String enemyClass,
		int x,
		int y,
		int width,
		int height,
		int hp,
		int attackRate,
		int score) {
		Enemy enemy = null;
		try {
			Class argClass[] =
				{
					applet.getClass(),
					this.getClass(),
					new Integer(x).getClass(),
					new Integer(y).getClass(),
					new Integer(width).getClass(),
					new Integer(height).getClass(),
					new Integer(attackRate).getClass(),
					applet
						.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("EnemyImageDirectory")
								+ enemyClass
								+ Shooting.config.get("EnemyImageExt"))
						.getClass(),
					new Integer(hp).getClass(),
					new Integer(score).getClass(),
					rand.getClass(),
					drawable.getClass()};
			Constructor con[] =
				Class
					.forName(
						Shooting.config.get("EnemyPackagePath") + enemyClass)
					.getConstructors();
			Object initArgs[] =
				{
					applet,
					this,
					new Integer(x),
					new Integer(y),
					new Integer(width),
					new Integer(height),
					new Integer(attackRate),
					applet.getImage(
						applet.getDocumentBase(),
						Shooting.config.get("EnemyImageDirectory")
							+ enemyClass
							+ Shooting.config.get("EnemyImageExt")),
					new Integer(hp),
					new Integer(score),
					rand,
					drawable };
			if (enemyClass == "Boss") {
				boss = (Enemy) (con[0].newInstance(initArgs));
				group.addTeki(boss);
			} else {
				enemy = (Enemy) (con[0].newInstance(initArgs));
				group.addTeki(enemy);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.highScore += score;
		return enemy;
	}

	protected Enemy addEnemy(
		String enemyClass,
		int x,
		int y,
		int width,
		int height,
		int hp,
		int attackRate,
		int score,
		String itemName) {
		Enemy enemy = null;
		enemy =
			addEnemy(enemyClass, x, y, width, height, hp, attackRate, score);
		addItem(enemy, itemName);
		return enemy;
	}

	private void addItem(Enemy enemy, String itemName) {
		Item item = null;
		try {
			Class argClass[] =
				{
					enemy.getClass(),
					jiki.getClass(),
					applet.getClass(),
					applet
						.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("ItemImageDirectory")
								+ itemName
								+ Shooting.config.get("ItemImageExt"))
						.getClass(),
					drawable.getClass(),
					offGra.getClass()};
			Constructor con[] =
				Class
					.forName(Shooting.config.get("ItemPackagePath") + itemName)
					.getConstructors();
			Object initArgs[] =
				{
					enemy,
					jiki,
					applet,
					applet.getImage(
						applet.getDocumentBase(),
						Shooting.config.get("ItemImageDirectory")
							+ itemName
							+ Shooting.config.get("ItemImageExt")),
					drawable,
					offGra };
			item = (Item) (con[0].newInstance(initArgs));
		} catch (Exception e) {
			e.printStackTrace();
		}
		enemy.setItem(item);
	}

	public Group getGroup() {
		return group;
	}

	public Jiki getJiki() {
		return jiki;
	}

	public Graphics getOffGra() {
		return offGra;
	}

	private boolean isGameEnd() {
		Font font =
			new Font(Shooting.config.get("GameEndFont"), Font.ITALIC, 40);
		if (jiki.isDead()) {
			MyGraphics.drawStringToCenter(
				applet,
				offGra,
				font,
				Color.black,
				Shooting.config.get("GameOverText"));
			return true;
		} else if (jiki.getScore() >= getHighScore() && boss.isDead()) {
			MyGraphics.drawStringToCenter(
				applet,
				offGra,
				font,
				Color.black,
				Shooting.config.get("GamePerfectClearText"));
			return true;
		} else if (boss != null && boss.isDead()) {
			MyGraphics.drawStringToCenter(
				applet,
				offGra,
				font,
				Color.black,
				Shooting.config.get("GameClearText"));
			return true;
		}
		return false;
	}

	public void keyPressed(KeyEvent arg0) {
		if (arg0.getKeyCode() == KeyEvent.VK_LEFT) {
			Jiki.left = true;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_RIGHT) {
			Jiki.right = true;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_UP) {
			Jiki.up = true;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_DOWN) {
			Jiki.down = true;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_Z) {
			Jiki.attack = true;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_X) {
			Jiki.bombAttack = true;
		}
	}

	public void keyReleased(KeyEvent arg0) {
		if (arg0.getKeyCode() == KeyEvent.VK_LEFT) {
			Jiki.left = false;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_RIGHT) {
			Jiki.right = false;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_UP) {
			Jiki.up = false;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_DOWN) {
			Jiki.down = false;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_Z) {
			Jiki.attack = false;
		}
		if (arg0.getKeyCode() == KeyEvent.VK_X) {
			Jiki.bombAttack = false;
		}
	}

	public boolean paint(Graphics g) {
		Drawable removes[] = new Drawable[200];
		int del = 0;
		offGra.setColor(applet.getBackground());
		offGra.fillRect(0, 0, applet.getWidth(), applet.getHeight());
		back.drawImage(offGra);
		jiki.drawImage(offGra);
		group.drawImage(offGra);
		Iterator it = drawable.iterator();
		while (it.hasNext()) {
			Drawable draw = (Drawable) it.next();
			if (draw.run()) {
				if (draw instanceof BombShot) {
					if (((BombShot) draw).getY()
						< - ((BombShot) draw).getHeight()) {
						removes[del++] = draw;
					}
				} else {
					removes[del++] = draw;
				}
			}
			draw.drawImage(offGra);
		}
		paintString();
		for (int i = 0; i < del; i++) {
			drawable.remove(removes[i]);
		}
		if (!isGameEnd()) {
			g.drawImage(offImage, 0, 0, applet);
		} else {
			g.drawImage(offImage, 0, 0, applet);
			return true;
		}
		return false;
	}

	private void paintString() {
		offGra.setColor(Color.black);
		if (jiki.getHp() > 0) {
			offGra.drawString(
				"SCORE:" + jiki.getScore(),
				0,
				applet.getHeight() - 60);
			offGra.drawString("HP@@:", 0, applet.getHeight() - 40);
			for (int i = 0; i < jiki.getHp(); i++) {
				offGra.drawString("", 40 + i * 10, applet.getHeight() - 40);
			}
			offGra.drawString("BOMB:", 0, applet.getHeight() - 20);
			for (int i = 0; i < jiki.getBombCount(); i++) {
				offGra.drawString("", 40 + i * 10, applet.getHeight() - 20);
			}
		} else {
			offGra.drawString(
				"SCORE:" + jiki.getScore(),
				0,
				applet.getHeight() - 40);
			offGra.drawString("HP:", 0, applet.getHeight() - 20);
		}
		offGra.setColor(applet.getBackground());
	}

	public void waitEnemyDead() {
		while (true) {
			if (group.getSize() <= 0) {
				break;
			}
			try {
				Thread.sleep(
					Integer.parseInt(Shooting.config.get("EnemyDeadWaitTime")));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

	protected int getHighScore() {
		return this.highScore;
	}

}
