package shooting_0_17.game;

import java.applet.Applet;
import java.awt.Color;
import java.util.Random;
import java.util.Vector;

import shooting_0_17.Back;
import shooting_0_17.Shooting;
import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.strategy.DoubleShotStrategy;

public class NormalGame extends Game {

	public NormalGame(Applet applet) {
		super(applet);
		init();
	}

	private void init() {
		score = 0;
		applet.setBackground(Color.white);
		offImage = applet.createImage(applet.getWidth(), applet.getHeight());
		offGra = offImage.getGraphics();
		drawable = new Vector();
		back = new Back(Back, 0, -500, 800, 1000, -1, applet);
		new Thread(back).start();
		rand = new Random();
		group = new Group();
		jiki =
			new Jiki(
				applet,
				this,
				100,
				applet.getHeight() - HeroHeight,
				HeroWidth,
				HeroHeight,
				applet.getImage(applet.getDocumentBase(), Hero),
				10,
				NormalLevelShotInterval,
				drawable);
		jiki.setBombCount(2);
		jiki.setShotStrategy(new DoubleShotStrategy());
		new Thread(jiki).start();
		jiki.setGroup(group);
		group.setJiki(jiki);
	}

	public void run() {
		addEnemy_(100, -100);
		addEnemy_(200, -100);
		addEnemy_(300, -100);
		addEnemy_(400, -100);
		addEnemy_(50, -230);
		addEnemy_(150, -230);
		addEnemy_(250, -230);
		addEnemy_(100, -360);
		addEnemy_(250, -360);
		addEnemy_(400, -360, "SpeedUpItem");
		addEnemy_(30, -490);
		addEnemy_(160, -490, "ShotIntervalUpItem");
		addEnemy_(290, -490);
		addEnemy_(100, -620);
		addEnemy_(200, -620);
		addEnemy_(300, -620);
		addEnemy_(400, -620);
		addEnemy_(150, -750, "AddOptionItem");
		addEnemy_(300, -750);
		addEnemy_(450, -750);
		addEnemy_(100, -900);
		addEnemy_(200, -900);
		addEnemy_(300, -900);
		addEnemy_(400, -900);
		addEnemy_ThreeWay(150, -1800, "ThreeWayShotItem");

		addEnemy_Straight(100, -1000);
		addEnemy_Straight(350, -1000);
		addEnemy_Straight(450, -1000);
		addEnemy_Straight(700, -1000);
		addEnemy_Straight(180, -2500);
		addEnemy_Straight(330, -2500);
		addEnemy_Straight(480, -2500);
		addEnemy_Straight(30, -4500);
		addEnemy_Straight(180, -4500);
		addEnemy_Straight(330, -4500);
		addEnemy_Straight(480, -4500);
		addEnemy_Straight(630, -4500);

		addEnemy_FiveWay(300, -750, "AddBombItem");
		addEnemy_FiveWay(500, -750);

		waitEnemyDead();

		addEnemy_(0, -100, "SpeedUpItem");
		addEnemy_(150, -100);
		addEnemy_(300, -100);
		addEnemy_(450, -100);
		addEnemy_(150, -230);
		addEnemy_(250, -230);
		addEnemy_(350, -230, "DoubleShotItem");
		addEnemy_(50, -360);
		addEnemy_(150, -360);
		addEnemy_(250, -360);
		addEnemy_(350, -360, "ShotIntervalUpItem");
		addEnemy_(450, -360);
		addEnemy_(100, -490);
		addEnemy_(210, -490, "AddOptionItem");
		addEnemy_(320, -490);
		addEnemy_(430, -490);
		addEnemy_(50, -620);
		addEnemy_(150, -620);
		addEnemy_(250, -620);
		addEnemy_(350, -620);
		addEnemy_(450, -620, "SpeedUpItem");
		addEnemy_(100, -750);
		addEnemy_(250, -750);
		addEnemy_(350, -750);
		addEnemy_(500, -750);
		addEnemy_ThreeWay(0, -1500, "ThreeWayShotItem");
		addEnemy_ThreeWay(200, -1500, "ThreeWayShotItem");

		addEnemy_Straight(100, -1000);
		addEnemy_Straight(350, -1000);
		addEnemy_Straight(450, -1000);
		addEnemy_Straight(700, -1000);
		addEnemy_Straight(30, -3000);
		addEnemy_Straight(180, -3000);
		addEnemy_Straight(330, -3000);
		addEnemy_Straight(480, -3000);
		addEnemy_Straight(630, -3000);

		addEnemy_FiveWay(300, -600);
		addEnemy_FiveWay(500, -600, "AddBombItem");

		waitEnemyDead();

		addEnemy_Straight(30, -300);
		addEnemy_Straight(130, -400);
		addEnemy_Straight(230, -500);
		addEnemy_Straight(330, -600, "AddBarrierItem");
		addEnemy_Straight(430, -700);
		addEnemy_Straight(530, -800);
		addEnemy_Straight(630, -900);
		addEnemy_Straight(730, -1000);
		addEnemy_Straight(730, -300);
		addEnemy_Straight(630, -400);
		addEnemy_Straight(530, -500);
		addEnemy_Straight(430, -600);
		addEnemy_Straight(330, -700);
		addEnemy_Straight(230, -800);
		addEnemy_Straight(130, -900);
		addEnemy_Straight(30, -1000);
		addEnemy_Homing(0, -500);
		addEnemy_Homing(200, -500);
		addEnemy_Homing(600, -500);
		addEnemy_Homing(800, -500);
		addEnemy("Boss", 100, -900, 100, 100, 200, 8, 100);
	}

	private void addEnemy_(int x, int y) {
		addEnemy("Enemy", x, y, NormalEnemyWidth, NormalEnemyHeight, 2, 2, 10);
	}

	private void addEnemy_(int x, int y, String itemName) {
		addEnemy(
			"Enemy",
			x,
			y,
			NormalEnemyWidth,
			NormalEnemyHeight,
			2,
			2,
			10,
			itemName);
	}

	private void addEnemy_Straight(int x, int y) {
		addEnemy(
			"StraightEnemy",
			x,
			y,
			NormalEnemyWidth,
			NormalEnemyHeight,
			1,
			3,
			10);
	}

	private void addEnemy_Straight(int x, int y, String itemName) {
		addEnemy(
			"StraightEnemy",
			x,
			y,
			NormalEnemyWidth,
			NormalEnemyHeight,
			1,
			3,
			10,
			itemName);
	}

	private void addEnemy_ThreeWay(int x, int y, String itemName) {
		addEnemy(
			"ThreeWayEnemy",
			x,
			y,
			Integer.parseInt(Shooting.config.get("ThreeWayEnemyWidth")),
			Integer.parseInt(Shooting.config.get("ThreeWayEnemyHeight")),
			30,
			5,
			50,
			itemName);
	}

	private void addEnemy_Homing(int x, int y) {
		addEnemy(
			"HomingEnemy",
			x,
			y,
			NormalEnemyWidth,
			NormalEnemyHeight,
			10,
			4,
			50);
	}

	private void addEnemy_FiveWay(int x, int y) {
		addEnemy(
			"FiveWayEnemy",
			x,
			y,
			Integer.parseInt(Shooting.config.get("FiveWayEnemyWidth")),
			Integer.parseInt(Shooting.config.get("FiveWayEnemyHeight")),
			20,
			2,
			20);
	}

	private void addEnemy_FiveWay(int x, int y, String itemName) {
		addEnemy(
			"FiveWayEnemy",
			x,
			y,
			Integer.parseInt(Shooting.config.get("FiveWayEnemyWidth")),
			Integer.parseInt(Shooting.config.get("FiveWayEnemyHeight")),
			10,
			2,
			20,
			itemName);
	}

}
