package shooting_0_17.item;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Vector;

import shooting_0_17.Drawable;
import shooting_0_17.Shooting;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;

public abstract class Item implements Drawable {

	protected Vector shots;
	protected Jiki jiki;
	protected Kitai kitai;
	protected Applet applet;
	protected boolean flag;
	protected int mv;
	protected Image img;
	protected int x;
	protected int y;
	protected int width;
	protected int height;
	protected Graphics offGra;

	public Item(
		Kitai kitai,
		Jiki jiki,
		Applet applet,
		Image img,
		Vector shots,
		Graphics offGra) {
		this.applet = applet;
		this.jiki = jiki;
		this.kitai = kitai;
		this.flag = true;
		this.img = img;
		this.shots = shots;
		this.offGra = offGra;
		this.width = Integer.parseInt(Shooting.config.get("ItemWidth"));
		this.height = Integer.parseInt(Shooting.config.get("ItemHeight"));
		this.mv = Integer.parseInt(Shooting.config.get("ItemDropSpeed"));
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public void setX(int x) {
		this.x = x;
	}

	public void setY(int y) {
		this.y = y;
	}

	public Image getImg() {
		return img;
	}

	public Kitai getJiki() {
		return jiki;
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	public void setHeight(int i) {
		height = i;
	}

	public void setWidth(int i) {
		width = i;
	}

	public void setFlag(boolean flag) {
		this.flag = flag;
	}

	public boolean run() {
		if (!flag) {
			move();
			drawImage(offGra);
			if (checkKitai()) {
				return true;
			}
			if (this.getY() > applet.getHeight()) {
				return true;
			}
		}
		return false;
	}

	protected void move() {
		this.y -= mv;
	}

	protected boolean checkKitai() {
		if ((this.getX() - jiki.getX() < jiki.getWidth())
			&& (this.getX() - jiki.getX() > -width)
			&& (this.getY() - jiki.getY() < jiki.getWidth())
			&& (this.getY() - jiki.getY() > -height)) {
			check(jiki);
			jiki.setDefault();
			flag = true;
			return true;
		} else if (
			jiki.getRightOption() != null
				&& (this.getX() - jiki.getRightOption().getX()
					< jiki.getRightOption().getWidth())
				&& (this.getX() - jiki.getRightOption().getX() > -width)
				&& (this.getY() - jiki.getRightOption().getY()
					< jiki.getRightOption().getWidth())
				&& (this.getY() - jiki.getRightOption().getY() > -height)) {
			check(jiki.getRightOption());
			jiki.setDefault();
			flag = true;
			return true;
		} else if (
			jiki.getLeftOption() != null
				&& (this.getX() - jiki.getLeftOption().getX()
					< jiki.getLeftOption().getWidth())
				&& (this.getX() - jiki.getLeftOption().getX() > -width)
				&& (this.getY() - jiki.getLeftOption().getY()
					< jiki.getLeftOption().getWidth())
				&& (this.getY() - jiki.getLeftOption().getY() > -height)) {
			check(jiki.getLeftOption());
			jiki.setDefault();
			flag = true;
			return true;
		}
		return false;
	}

	public void drawImage(Graphics g) {
		g.drawImage(
			getImg(),
			x + ((kitai.getWidth() - width) / 2),
			y,
			width,
			height,
			null);
	}

	public abstract void check(Jiki jiki);

}
