package shooting_0_17.kitai;

import java.applet.Applet;
import java.awt.Image;
import java.util.Random;
import java.util.Vector;

import shooting_0_17.Shooting;
import shooting_0_17.game.Game;
import shooting_0_17.item.Item;

public class Enemy extends Kitai implements Runnable {

	protected Item item;

	public Enemy(
		Applet applet,
		Game game,
		int x,
		int y,
		int width,
		int height,
		int attackRate,
		Image img,
		int hp,
		int score,
		Random rand,
		Vector shot) {
		super(
			applet,
			game,
			x,
			y,
			width,
			height,
			attackRate,
			img,
			hp,
			score,
			rand,
			shot);
		this.shotSpeed =
			Integer.parseInt(Shooting.config.get("EnemyNormalShotSpeed"));
		this.speed = Integer.parseInt(Shooting.config.get("EnemyNormalSpeed"));
		this.shotImg =
			applet.getImage(
				applet.getDocumentBase(),
				Shooting.config.get("EnemyNormalShotImage"));
		this.shotWidth =
			Integer.parseInt(Shooting.config.get("EnemyNormalShotWidth"));
		this.shotHeight =
			Integer.parseInt(Shooting.config.get("EnemyNormalShotHeight"));
	}

	public void setItem(Item item) {
		this.item = item;
	}

	public void run() {
		while (true) {
			move();
			if (isDead()) {
				break;
			}
			if (getY() > applet.getHeight()) {
				break;
			}
		}
	}

	public void move() {
		for (int n = 0; n < 30; n++) {
			mv(Kitai.X, speed);
			mv(Kitai.Y, 3);
		}
		for (int n = 0; n < 30; n++) {
			mv(Kitai.X, -speed);
			mv(Kitai.Y, 3);
		}
	}

	protected void mv(int houkou, int ryou) {
		super.move(houkou, ryou);
		if (isDead()) {
			return;
		}
		try {
			Thread.sleep(40);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		attack();
	}

	public void attack() {
		if (this.getY() < -this.getHeight()) {
			return;
		}
		int i = rand.nextInt(100);
		if (i < attackRate) {
			shotStrategy.shot(
				this,
				group,
				applet,
				game.getOffGra(),
				x,
				y,
				shotWidth,
				shotHeight,
				shotSpeed,
				shotImg,
				shot,
				"jiki");
		}

	}

	public void damage(int damage) {
		hp -= damage;
		if (hp <= 0) {
			this.dead = true;
			if (item != null) {
				shot.add(item);
				item.setX(getX());
				item.setY(getY());
				item.setFlag(false);
			}
		}
	}

}
