package shooting_0_17.kitai;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import shooting_0_17.Shooting;
import shooting_0_17.game.*;
import shooting_0_17.strategy.BombShotStrategy;
import shooting_0_17.strategy.ShotStrategy;

public class Jiki extends Kitai implements Runnable {

	private Date date;
	private int shotInterval;

	protected boolean end;

	public static boolean left;
	public static boolean right;
	public static boolean up;
	public static boolean down;
	public static boolean attack;
	public static boolean bombAttack;

	private Image bombShotImage;
	private ShotStrategy bombStrategy;
	private int bombCount;
	private int bombWidth;
	private int bombHeight;

	private Option rightOption;
	private Option leftOption;
	private Barrier barrier;

	public Jiki(
		Applet applet,
		Game game,
		int x,
		int y,
		int width,
		int height,
		Image img,
		int hp,
		int shotInterval,
		Vector shot) {
		super(applet, game, x, y, width, height, 0, img, hp, 0, null, shot);
		this.date = new Date();
		this.shotSpeed = Integer.parseInt(Shooting.config.get("HeroShotSpeed"));
		this.shotInterval = shotInterval;
		this.speed = Integer.parseInt(Shooting.config.get("HeroNormalSpeed"));
		this.end = true;
		this.bombStrategy = new BombShotStrategy();
		this.bombCount = 1;
		this.bombWidth =
			Integer.parseInt(Shooting.config.get("HeroNormalBombWidth"));
		this.bombHeight =
			Integer.parseInt(Shooting.config.get("HeroNormalBombHeight"));
		this.shotImg =
			applet.getImage(
				applet.getDocumentBase(),
				Shooting.config.get("HeroNormalShotImage"));
		this.bombShotImage =
			applet.getImage(
				applet.getDocumentBase(),
				Shooting.config.get("HeroBombShotImage"));
		this.shotWidth =
			Integer.parseInt(Shooting.config.get("HeroNormalShotWidth"));
		this.shotHeight =
			Integer.parseInt(Shooting.config.get("HeroNormalShotHeight"));
	}

	public ShotStrategy getBombStrategy() {
		return bombStrategy;
	}

	public void setBombStrategy(ShotStrategy strategy) {
		bombStrategy = strategy;
	}

	public int getBombCount() {
		return bombCount;
	}

	public void setBombCount(int i) {
		bombCount = i;
	}

	public int getBombHeight() {
		return bombHeight;
	}

	public int getBombWidth() {
		return bombWidth;
	}

	public void setBombHeight(int i) {
		bombHeight = i;
	}

	public void setBombWidth(int i) {
		bombWidth = i;
	}

	public int getShotInterval() {
		return shotInterval;
	}

	public void setShotInterval(int shotInterval) {
		this.shotInterval = shotInterval;
	}

	public Applet getApplet() {
		return applet;
	}

	public void setGroup(Group group) {
		this.group = group;
		if (rightOption != null) {
			rightOption.setGroup(group);
		}
		if (leftOption != null) {
			leftOption.setGroup(group);
		}
		if (barrier != null) {
			barrier.setGroup(group);
		}
	}

	public void addBarrier() {
		if (barrier == null) {
			barrier =
				new Barrier(
					applet,
					game,
					x,
					y - height / 2,
					width,
					height / 2,
					applet.getImage(
						applet.getDocumentBase(),
						Shooting.config.get("BarrierImage")),
					Integer.parseInt(Shooting.config.get("BarrierHP")),
					shotInterval,
					shot);
			barrier.setGroup(group);
		}
	}

	public void addOption() {
		if (rightOption == null) {
			rightOption =
				new Option(
					applet,
					game,
					x + width + width / 2,
					y + height / 2,
					width / 2,
					height / 2,
					img,
					Integer.parseInt(Shooting.config.get("OptionHP")),
					shotInterval,
					shot);
			rightOption.setGroup(group);
		} else if (leftOption == null) {
			leftOption =
				new Option(
					applet,
					game,
					x - width,
					y + height / 2,
					width / 2,
					height / 2,
					img,
					Integer.parseInt(Shooting.config.get("OptionHP")),
					shotInterval,
					shot);
			leftOption.setGroup(group);
		}
	}

	public Option getRightOption() {
		return rightOption;
	}

	public Option getLeftOption() {
		return leftOption;
	}

	public Barrier getBarrier() {
		return barrier;
	}

	public void setRightOptionNull() {
		this.rightOption = null;
	}

	public void setLeftOptionNull() {
		this.leftOption = null;
	}

	public void setBarrierNull() {
		this.barrier = null;
	}

	public void damage(int damage) {
		hp -= damage;
		if (hp <= 0) {
			this.dead = true;
		}
	}

	public void end() {
		this.end = false;
	}

	public void run() {
		while (end) {
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
			if (left == true) {
				move(Kitai.X, -speed);
				if (getX() - speed < 0) {
					setX(0);
				}
			}
			if (right == true) {
				move(Kitai.X, speed);
				if (getX()
					+ speed
					+ Integer.parseInt(Shooting.config.get("HeroWidth"))
					> applet.getWidth()) {
					setX(
						applet.getWidth()
							- Integer.parseInt(Shooting.config.get("HeroWidth")));
				}
			}
			if (up == true) {
				move(Kitai.Y, -speed);
				if (getY() - speed < 0) {
					setY(0);
				}
			}
			if (down == true) {
				move(Kitai.Y, speed);
				if (getY()
					+ speed
					+ Integer.parseInt(Shooting.config.get("HeroHeight"))
					> applet.getHeight()) {
					setY(
						applet.getHeight()
							- Integer.parseInt(
								Shooting.config.get("HeroHeight")));
				}
			}
			if (attack == true) {
				attack();
			}
			if (bombAttack == true) {
				bombAttack();
			}
			hitBody();
		}
	}

	public void move(int jiku, int m) {
		if (jiku == X) {
			this.x += m;
			if (rightOption != null) {
				rightOption.setX(x + width + width / 2);
			}
			if (leftOption != null) {
				leftOption.setX(x - width);
			}
			if (barrier != null) {
				barrier.setX(x);
			}
		} else if (jiku == Y) {
			this.y += m;
			if (rightOption != null) {
				rightOption.setY(y + height / 2);
			}
			if (leftOption != null) {
				leftOption.setY(y + height / 2);
			}
			if (barrier != null) {
				barrier.setY(y - height);
			}
		}
		if (rightOption != null) {
			if (rightOption.getHp() <= 0) {
				rightOption = null;
			}
		}
		if (leftOption != null) {
			if (leftOption.getHp() <= 0) {
				leftOption = null;
			}
		}
		if (barrier != null) {
			if (barrier.getHp() <= 0) {
				barrier = null;
			}
		}
	}

	protected void hitBody() {
		Iterator it = game.getGroup().iterator();
		while (it.hasNext()) {
			Enemy enemy = (Enemy) it.next();
			if (enemy instanceof Explode) {
				continue;
			}
			if (((this.getX() - enemy.getX() < enemy.getWidth())
				&& (this.getX() - enemy.getX() > 0)
				&& (this.getY() - enemy.getY() < enemy.getHeight())
				&& (this.getY() - enemy.getY() > -this.getHeight()))
				|| ((enemy.getX() - this.getX() < width)
					&& (enemy.getX() - this.getX() > 0)
					&& (this.getY() - enemy.getY() < enemy.getHeight())
					&& (this.getY() - enemy.getY() > -this.getHeight()))) {
				this.damage(1);
				group.addTeki(
					new Explode(
						applet,
						this.getGame(),
						this.getX(),
						this.getY(),
						this.getWidth(),
						this.getHeight(),
						0,
						applet.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("DeadImage")),
						10,
						0,
						null,
						null));
				break;
			}
			if (rightOption != null) {
				if (rightOption.hitBody(enemy)) {
					break;
				}
			}
			if (leftOption != null) {
				if (leftOption.hitBody(enemy)) {
					break;
				}
			}
			if (barrier != null) {
				if (barrier.hitBody(enemy)) {
					break;
				}
			}
		}
	}

	public void attack() {
		if (new Date().getTime() - date.getTime() < shotInterval) {
			return;
		}
		date = new Date();
		shotStrategy.shot(
			this,
			group,
			applet,
			game.getOffGra(),
			x,
			y,
			shotWidth,
			shotHeight,
			shotSpeed,
			shotImg,
			shot,
			"group");
		if (rightOption != null) {
			rightOption.attack();
		}
		if (leftOption != null) {
			leftOption.attack();
		}
	}

	public void bombAttack() {
		if (new Date().getTime() - date.getTime() < shotInterval) {
			return;
		}
		if (bombCount == 0) {
			return;
		}
		bombCount--;
		date = new Date();
		bombStrategy.shot(
			this,
			group,
			applet,
			game.getOffGra(),
			x,
			y,
			bombWidth,
			bombHeight,
			shotSpeed,
			bombShotImage,
			shot,
			"group");
	}

	public void drawImage(Graphics g) {
		g.drawImage(img, x, y, width, height, applet);
		if (rightOption != null) {
			g.drawImage(
				rightOption.getImg(),
				rightOption.getX(),
				rightOption.getY(),
				rightOption.getWidth(),
				rightOption.getHeight(),
				applet);
		}
		if (leftOption != null) {
			g.drawImage(
				leftOption.getImg(),
				leftOption.getX(),
				leftOption.getY(),
				leftOption.getWidth(),
				leftOption.getHeight(),
				applet);
		}
		if (barrier != null) {
			g.drawImage(
				barrier.getImg(),
				barrier.getX(),
				barrier.getY(),
				barrier.getWidth(),
				barrier.getHeight(),
				applet);
		}
	}

	public void setDefault() {

	}

}
