package shooting_0_17.kitai;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Random;
import java.util.Vector;

import shooting_0_17.game.*;
import shooting_0_17.strategy.*;

public abstract class Kitai {

	public static int X = 1;
	public static int Y = 2;

	protected int score;
	protected Applet applet;
	protected Game game;
	protected Group group;
	protected Vector shot;
	protected int x;
	protected int y;
	protected Image img;
	protected Image shotImg;
	protected boolean dead;
	protected Random rand;
	protected int hp;
	protected int speed;
	protected int width;
	protected int height;
	protected int attackRate;
	protected ShotStrategy shotStrategy;
	protected int shotSpeed;
	protected int shotWidth;
	protected int shotHeight;

	public Kitai(
		Applet applet,
		Game game,
		int x,
		int y,
		int width,
		int height,
		int attackRate,
		Image img,
		int hp,
		int score,
		Random rand,
		Vector shot) {
		this.applet = applet;
		this.game = game;
		this.hp = hp;
		this.shot = shot;
		this.x = x;
		this.y = y;
		this.img = img;
		this.score = score;
		this.dead = false;
		this.rand = rand;
		this.width = width;
		this.height = height;
		this.attackRate = attackRate;
		this.shotStrategy = new NormalShotStrategy();
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public void setX(int i) {
		x = i;
	}

	public void setY(int i) {
		y = i;
	}

	public int getHp() {
		return hp;
	}

	public void setHp(int i) {
		hp = i;
	}

	public int getScore() {
		return score;
	}

	public void setScore(int score) {
		this.score = score;
	}

	public Image getImg() {
		return img;
	}

	public void setImg(Image image) {
		img = image;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public boolean isDead() {
		return dead;
	}

	public int getWidth() {
		return width;
	}

	public int getHeight() {
		return height;
	}

	public ShotStrategy getShotStrategy() {
		return shotStrategy;
	}

	public void setShotStrategy(ShotStrategy jikiShot) {
		this.shotStrategy = jikiShot;
	}

	public int getShotSpeed() {
		return shotSpeed;
	}

	public void setShotSpeed(int i) {
		shotSpeed = i;
	}

	public Image getShotImg() {
		return shotImg;
	}

	public void setShotImg(Image image) {
		shotImg = image;
	}

	public void setShotHeight(int i) {
		shotHeight = i;
	}

	public void setShotWidth(int i) {
		shotWidth = i;
	}

	public int getSpeed() {
		return speed;
	}

	public void setSpeed(int i) {
		speed = i;
	}

	public Game getGame() {
		return game;
	}

	public void move(int jiku, int m) {
		if (jiku == X) {
			this.x += m;
		} else if (jiku == Y) {
			this.y += m;
		}
	}

	public void drawImage(Graphics g) {
		g.drawImage(img, x, y, width, height, applet);
	}

	public abstract void attack();

	public abstract void damage(int damage);

}
