package shooting_0_17.shot;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Iterator;
import java.util.Vector;

import shooting_0_17.Drawable;
import shooting_0_17.Shooting;
import shooting_0_17.kitai.Barrier;
import shooting_0_17.kitai.Explode;
import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;
import shooting_0_17.kitai.Option;

public class Shot implements Drawable {

	protected Vector shots;
	protected Group group;
	protected Jiki jiki;
	protected Applet applet;
	protected Graphics offGra;
	protected boolean flag;
	protected int x;
	protected int y;
	protected int mv;
	protected int width;
	protected int height;
	protected Image img;
	protected String target;
	protected int damage;

	public Shot(
		Applet applet,
		Graphics offGra,
		int x,
		int y,
		int width,
		int height,
		int mv,
		Image img,
		Vector shots) {
		this.applet = applet;
		this.offGra = offGra;
		this.group = null;
		this.jiki = null;
		this.flag = false;
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		this.mv = mv;
		this.img = img;
		this.shots = shots;
		this.damage = 1;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public void setX(int i) {
		x = i;
	}

	public void setY(int i) {
		y = i;
	}

	public int getHeight() {
		return height;
	}

	public int getWidth() {
		return width;
	}

	public Jiki getJiki() {
		return jiki;
	}

	public void setTarget(String target) {
		this.target = target;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public void setJiki(Jiki jiki) {
		this.jiki = jiki;
	}

	public int getDamage() {
		return damage;
	}

	public void setDamage(int i) {
		damage = i;
	}

	public boolean run() {
		if (!flag) {
			move();
			if (this.getY() < 0 || this.getY() > applet.getHeight()) {
				return true;
			}
			if (target == "group") {
				return checkGroup();
			} else if (target == "jiki") {
				return checkJiki();
			}
		}
		return true;
	}

	protected void move() {
		this.y -= mv;
	}

	protected boolean checkGroup() {
		Iterator it = group.iterator();
		while (it.hasNext()) {
			if (checkKitai((Kitai) it.next())) {
				return true;
			}
		}
		return false;
	}

	protected boolean checkJiki() {
		Option rightOption = null;
		Option leftOption = null;
		Barrier barrier = null;
		if ((this.getX() - jiki.getX() < jiki.getWidth())
			&& (this.getX() - jiki.getX() > -width)
			&& (this.getY() - jiki.getY() < jiki.getHeight())
			&& (this.getY() - jiki.getY() > -height)) {
			jiki.damage(damage);
			flag = true;
			group.addTeki(
				new Explode(
					applet,
					jiki.getGame(),
					jiki.getX(),
					jiki.getY(),
					jiki.getWidth(),
					jiki.getHeight(),
					0,
					applet.getImage(
						applet.getDocumentBase(),
						Shooting.config.get("DeadImage")),
					10,
					0,
					null,
					null));
			return true;
		}
		if ((rightOption = jiki.getRightOption()) != null) {
			if ((this.getX() - rightOption.getX() < rightOption.getWidth())
				&& (this.getX() - rightOption.getX() > -width)
				&& (this.getY() - rightOption.getY() < rightOption.getHeight())
				&& (this.getY() - rightOption.getY() > -height)) {
				rightOption.damage(damage);
				flag = true;
				group.addTeki(
					new Explode(
						applet,
						rightOption.getGame(),
						rightOption.getX(),
						rightOption.getY(),
						rightOption.getWidth(),
						rightOption.getHeight(),
						0,
						applet.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("DeadImage")),
						10,
						0,
						null,
						null));
				if (jiki.getRightOption().getHp() <= 0) {
					jiki.setRightOptionNull();
				}
				return true;
			}
		}
		if ((leftOption = jiki.getLeftOption()) != null) {
			if ((this.getX() - leftOption.getX() < leftOption.getWidth())
				&& (this.getX() - leftOption.getX() > -width)
				&& (this.getY() - leftOption.getY() < leftOption.getHeight())
				&& (this.getY() - leftOption.getY() > -height)) {
				leftOption.damage(damage);
				flag = true;
				group.addTeki(
					new Explode(
						applet,
						leftOption.getGame(),
						leftOption.getX(),
						leftOption.getY(),
						leftOption.getWidth(),
						leftOption.getHeight(),
						0,
						applet.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("DeadImage")),
						10,
						0,
						null,
						null));
				if (jiki.getLeftOption().getHp() <= 0) {
					jiki.setLeftOptionNull();
				}
				return true;
			}
		}
		if ((barrier = jiki.getBarrier()) != null) {
			if ((this.getX() - barrier.getX() < barrier.getWidth())
				&& (this.getX() - barrier.getX() > -width)
				&& (this.getY() - barrier.getY() < barrier.getHeight())
				&& (this.getY() - barrier.getY() > -height)) {
				barrier.damage(damage);
				flag = true;
				group.addTeki(
					new Explode(
						applet,
						barrier.getGame(),
						barrier.getX(),
						barrier.getY(),
						barrier.getWidth(),
						barrier.getHeight(),
						0,
						applet.getImage(
							applet.getDocumentBase(),
							Shooting.config.get("DeadImage")),
						10,
						0,
						null,
						null));
				if (jiki.getBarrier().getHp() <= 0) {
					jiki.setBarrierNull();
				}
				return true;
			}
		}
		return false;
	}

	protected boolean checkKitai(Kitai kitai) {
		if (((this.getX() - kitai.getX() < kitai.getWidth())
			&& (this.getX() - kitai.getX() > 0)
			&& (this.getY() - kitai.getY() < kitai.getHeight())
			&& (this.getY() - kitai.getY() > -height))
			|| ((kitai.getX() - this.getX() < width)
				&& (kitai.getX() - this.getX() > 0)
				&& (this.getY() - kitai.getY() < kitai.getHeight())
				&& (this.getY() - kitai.getY() > -height))) {
			kitai.damage(damage);
			if (!jiki.isDead()) {
				if (kitai.isDead()) {
					jiki.setScore(jiki.getScore() + kitai.getScore());
				}
			}
			flag = true;
			group.addTeki(
				new Explode(
					applet,
					kitai.getGame(),
					kitai.getX(),
					kitai.getY(),
					kitai.getWidth(),
					kitai.getHeight(),
					0,
					applet.getImage(
						applet.getDocumentBase(),
						Shooting.config.get("DeadImage")),
					10,
					0,
					null,
					null));
			return true;
		}
		return false;
	}

	public void drawImage(Graphics g) {
		g.drawImage(img, x, y, width, height, applet);
	}

}
