package shooting_0_17.strategy;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Vector;

import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;
import shooting_0_17.kitai.Enemy;
import shooting_0_17.shot.BombShot;
import shooting_0_17.shot.Shot;

public class BombShotStrategy implements ShotStrategy {

	public void shot(
		Kitai kitai,
		Group group,
		Applet applet,
		Graphics offGra,
		int x,
		int y,
		int width,
		int height,
		int mv,
		Image img,
		Vector shots,
		String target) {
		if (kitai instanceof Jiki) {
			y = kitai.getY();
		} else if (kitai instanceof Enemy) {
			y = kitai.getY() + kitai.getWidth();
		}
		shots.clear();
		Shot st1 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots,
				0);
		st1.setDamage(1);
		st1.setTarget(target);
		shots.add(st1);
		st1.setGroup(group);
		if (kitai instanceof Jiki) {
			st1.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st1.setJiki(group.getJiki());
		}
		Shot st2 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots,
				7);
		st2.setDamage(1);
		st2.setTarget(target);
		shots.add(st2);
		st2.setGroup(group);
		if (kitai instanceof Jiki) {
			st2.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st2.setJiki(group.getJiki());
		}
		Shot st3 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots,
				-7);
		st3.setDamage(1);
		st3.setTarget(target);
		shots.add(st3);
		st3.setGroup(group);
		if (kitai instanceof Jiki) {
			st3.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st3.setJiki(group.getJiki());
		}
		Shot st4 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv / 2,
				img,
				shots,
				10);
		st4.setDamage(1);
		st4.setTarget(target);
		shots.add(st4);
		st4.setGroup(group);
		if (kitai instanceof Jiki) {
			st4.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st4.setJiki(group.getJiki());
		}
		Shot st5 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv / 2,
				img,
				shots,
				-10);
		st5.setDamage(1);
		st5.setTarget(target);
		shots.add(st5);
		st5.setGroup(group);
		if (kitai instanceof Jiki) {
			st5.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st5.setJiki(group.getJiki());
		}
		Shot st6 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				0,
				img,
				shots,
				10);
		st6.setDamage(1);
		st6.setTarget(target);
		shots.add(st6);
		st6.setGroup(group);
		if (kitai instanceof Jiki) {
			st6.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st6.setJiki(group.getJiki());
		}
		Shot st7 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				0,
				img,
				shots,
				-10);
		st7.setDamage(1);
		st7.setTarget(target);
		shots.add(st7);
		st7.setGroup(group);
		if (kitai instanceof Jiki) {
			st7.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st7.setJiki(group.getJiki());
		}
		Shot st8 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				-mv / 2,
				img,
				shots,
				10);
		st8.setDamage(1);
		st8.setTarget(target);
		shots.add(st8);
		st8.setGroup(group);
		if (kitai instanceof Jiki) {
			st8.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st8.setJiki(group.getJiki());
		}
		Shot st9 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				-mv / 2,
				img,
				shots,
				-10);
		st9.setDamage(1);
		st9.setTarget(target);
		shots.add(st9);
		st9.setGroup(group);
		if (kitai instanceof Jiki) {
			st9.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st9.setJiki(group.getJiki());
		}
		Shot st10 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				-mv,
				img,
				shots,
				7);
		st10.setDamage(1);
		st10.setTarget(target);
		shots.add(st10);
		st10.setGroup(group);
		if (kitai instanceof Jiki) {
			st10.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st10.setJiki(group.getJiki());
		}
		Shot st11 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				-mv,
				img,
				shots,
				-7);
		st11.setDamage(1);
		st11.setTarget(target);
		shots.add(st11);
		st11.setGroup(group);
		if (kitai instanceof Jiki) {
			st11.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st11.setJiki(group.getJiki());
		}
		Shot st12 =
			new BombShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				-mv,
				img,
				shots,
				0);
		st12.setDamage(1);
		st12.setTarget(target);
		shots.add(st12);
		st12.setGroup(group);
		if (kitai instanceof Jiki) {
			st12.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st12.setJiki(group.getJiki());
		}
	}

}
