package shooting_0_17.strategy;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Random;
import java.util.Vector;

import shooting_0_17.kitai.Enemy;
import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;
import shooting_0_17.shot.HomingShot;
import shooting_0_17.shot.NanameShot;
import shooting_0_17.shot.Shot;

public class BossShotStrategy implements ShotStrategy {

	private static Random rand;

	public BossShotStrategy() {
		rand = new Random();
	}

	public void shot(
		Kitai kitai,
		Group group,
		Applet applet,
		Graphics offGra,
		int x,
		int y,
		int width,
		int height,
		int mv,
		Image img,
		Vector shots,
		String target) {
		if (kitai instanceof Jiki) {
			y = kitai.getY();
		} else if (kitai instanceof Enemy) {
			y = kitai.getY() + kitai.getWidth();
		}
		if (rand.nextInt(10) < 8) {
			Shot st =
				new HomingShot(
					applet,
					offGra,
					kitai.getX() + ((kitai.getWidth() - width) / 2),
					y,
					width,
					height,
					mv,
					img,
					shots);
			st.setTarget(target);
			shots.add(st);
			st.setGroup(group);
			if (kitai instanceof Jiki) {
				st.setJiki((Jiki) kitai);
			} else if (kitai instanceof Enemy) {
				st.setJiki(group.getJiki());
			}
		} else {
			Shot st1 =
				new NanameShot(
					applet,
					offGra,
					kitai.getX() + ((kitai.getWidth() - width) / 2),
					y,
					width,
					height,
					mv,
					img,
					shots,
					2);
			st1.setTarget(target);
			st1.setGroup(group);
			shots.add(st1);
			if (kitai instanceof Jiki) {
				st1.setJiki((Jiki) kitai);
			} else if (kitai instanceof Enemy) {
				st1.setJiki(group.getJiki());
			}
			Shot st2 =
				new NanameShot(
					applet,
					offGra,
					kitai.getX() + ((kitai.getWidth() - width) / 2),
					y,
					width,
					height,
					mv,
					img,
					shots,
					-2);
			st2.setTarget(target);
			st2.setGroup(group);
			shots.add(st2);
			if (kitai instanceof Jiki) {
				st2.setJiki((Jiki) kitai);
			} else if (kitai instanceof Enemy) {
				st2.setJiki(group.getJiki());
			}
			Shot st3 =
				new Shot(
					applet,
					offGra,
					kitai.getX() + ((kitai.getWidth() - width) / 2),
					y,
					width,
					height,
					mv,
					img,
					shots);
			st3.setTarget(target);
			st3.setGroup(group);
			shots.add(st3);
			if (kitai instanceof Jiki) {
				st3.setJiki((Jiki) kitai);
			} else if (kitai instanceof Enemy) {
				st3.setJiki(group.getJiki());
			}
		}
	}

}
