package shooting_0_17.strategy;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Vector;

import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;
import shooting_0_17.kitai.Enemy;
import shooting_0_17.shot.Shot;

public class NormalShotStrategy implements ShotStrategy {

	public void shot(
		Kitai kitai,
		Group group,
		Applet applet,
		Graphics offGra,
		int x,
		int y,
		int width,
		int height,
		int mv,
		Image img,
		Vector shots,
		String target) {
		if (kitai instanceof Jiki) {
			y = kitai.getY();
		} else if (kitai instanceof Enemy) {
			y = kitai.getY() + kitai.getWidth();
		}
		Shot st =
			new Shot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots);
		st.setTarget(target);
		shots.add(st);
		st.setGroup(group);
		if (kitai instanceof Jiki) {
			st.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st.setJiki(group.getJiki());
		}
	}

}
