package shooting_0_17.strategy;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Vector;

import shooting_0_17.kitai.Group;
import shooting_0_17.kitai.Jiki;
import shooting_0_17.kitai.Kitai;
import shooting_0_17.kitai.Enemy;
import shooting_0_17.shot.NanameShot;
import shooting_0_17.shot.Shot;

public class ThreeWayShotStretegy implements ShotStrategy {

	public void shot(
		Kitai kitai,
		Group group,
		Applet applet,
		Graphics offGra,
		int x,
		int y,
		int width,
		int height,
		int mv,
		Image img,
		Vector shots,
		String target) {
		if (kitai instanceof Jiki) {
			y = kitai.getY();
		} else if (kitai instanceof Enemy) {
			y = kitai.getY() + kitai.getWidth();
		}
		Shot st1 =
			new NanameShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots,
				3);
		st1.setTarget(target);
		st1.setGroup(group);
		if (kitai instanceof Jiki) {
			st1.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st1.setJiki(group.getJiki());
		}
		shots.add(st1);
		Shot st2 =
			new NanameShot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots,
				-3);
		st2.setTarget(target);
		st2.setGroup(group);
		if (kitai instanceof Jiki) {
			st2.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st2.setJiki(group.getJiki());
		}
		shots.add(st2);
		Shot st3 =
			new Shot(
				applet,
				offGra,
				kitai.getX() + ((kitai.getWidth() - width) / 2),
				y,
				width,
				height,
				mv,
				img,
				shots);
		st3.setTarget(target);
		st3.setGroup(group);
		if (kitai instanceof Jiki) {
			st3.setJiki((Jiki) kitai);
		} else if (kitai instanceof Enemy) {
			st3.setJiki(group.getJiki());
		}
		shots.add(st3);
	}

}
