package utilities;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Insets;

public class MyGraphics {

	public static void drawStringToCenter(
		Container container,
		Graphics g,
		Font font,
		Color color,
		String str) {
		Font currentFont = g.getFont();
		Color currentColor = g.getColor();
		g.setFont(font);
		g.setColor(color);
		FontMetrics fm = container.getFontMetrics(g.getFont());
		Insets is = container.getInsets();
		int x =
			(container.getWidth() - is.left - is.right - fm.stringWidth(str))
				/ 2
				+ is.left;
		int y =
			(container.getHeight() - is.top - is.bottom - fm.getHeight()) / 2
				+ is.top
				+ fm.getAscent();
		g.drawString(str, x, y);
		g.setFont(currentFont);
		g.setColor(currentColor);
	}

	public static void drawStringToLeftTop(
		Container container,
		Graphics g,
		Font font,
		Color color,
		String str) {
		Font currentFont = g.getFont();
		Color currentColor = g.getColor();
		g.setFont(font);
		g.setColor(color);
		FontMetrics fm = container.getFontMetrics(g.getFont());
		Insets is = container.getInsets();
		g.drawString(str, is.left, fm.getAscent() + is.top);
		g.setFont(currentFont);
		g.setColor(currentColor);
	}

	public static void drawStringToLeftBottom(
		Container container,
		Graphics g,
		Font font,
		Color color,
		String str) {
		Font currentFont = g.getFont();
		Color currentColor = g.getColor();
		g.setFont(font);
		g.setColor(color);
		FontMetrics fm = container.getFontMetrics(g.getFont());
		Insets is = container.getInsets();
		g.drawString(str, is.left, container.getHeight() - is.bottom);
		g.setFont(currentFont);
		g.setColor(currentColor);
	}

	public static void drawStringToRightTop(
		Container container,
		Graphics g,
		Font font,
		Color color,
		String str) {
		Font currentFont = g.getFont();
		Color currentColor = g.getColor();
		g.setFont(font);
		g.setColor(color);
		FontMetrics fm = container.getFontMetrics(g.getFont());
		Insets is = container.getInsets();
		g.drawString(
			str,
			container.getWidth() - fm.stringWidth(str) + is.left,
			fm.getAscent() + is.top);
		g.setFont(currentFont);
		g.setColor(currentColor);
	}

	public static void drawStringToRightBottom(
		Container container,
		Graphics g,
		Font font,
		Color color,
		String str) {
		Font currentFont = g.getFont();
		Color currentColor = g.getColor();
		g.setFont(font);
		g.setColor(color);
		FontMetrics fm = container.getFontMetrics(g.getFont());
		Insets is = container.getInsets();
		g.drawString(
			str,
			container.getWidth() - fm.stringWidth(str) + is.left,
			container.getHeight() - is.bottom);
		g.setFont(currentFont);
		g.setColor(currentColor);
	}

}
